surface Blinn
(
 float Ks=0.5;
 float Kd=0.5;
 color SpecColour=1;
 float specularRollOff=0.002;
 float eccentricity=1;
)
{
// init the shader values 
normal Nf = faceforward(normalize(N),I);
vector V = -normalize(I);

// now calculate the shading values 
color Blinn=0;
float E;
vector H, Ln,  Nn;
float NH, NH2, NHSQ, Dd, Gg, VN, VH, LN, Ff, tmp;
float nondiff, nonspec;
illuminance( P , Nf, PI/2.0 )
{
if(eccentricity != 1)
	E = 1 / (eccentricity * eccentricity - 1);
else
	E = -1e5;
VN = V.Nf;
Ln = normalize(L);
H = normalize(Ln+V);
NH = Nf.H;
NHSQ = NH*NH;
NH2 = NH * 2;
VH = V.H;
LN = Ln.Nf;
if( VN < LN )
	{
	if( VN * NH2 < VH )
		Gg = NH2 / VH;
	else
		Gg = 1 / VN;
	}
else
	{
	if( LN * NH2 < VH )
		Gg = (LN * NH2) / (VH * VN);
	else
		Gg = 1 / VN;
	}
// poor man's Fresnel 
tmp = pow((1 - VH), 3);
Ff = tmp + (1 - tmp) * specularRollOff;
Blinn = Gg * Ff * SpecColour;



}

Ci= Oi*Cs * (Kd*diffuse(Nf))+(Ks*Blinn);
}
