surface basicPlastic
(
 float Ka=1;
 float Kd=0.5;
 float Ks=0.5;
 float size = 10;
 color specularcolor = 1;
)
{
/* init the shader values */
normal Nf = faceforward(normalize(N),I);
vector V = -normalize(I);

/* now calculate the shading values */


color Diffuse=0;
color Phong=0;
normal Nn=ntransform("object",N);
vector R = reflect( -normalize(V), normalize(N) );
	illuminance( P, Nf, PI/2 )
	{
	Diffuse += Cl * normalize(L).Nf;
	vector Ln = normalize(L);
	Phong += Cl * pow(max(0.0,R.Ln), size);	    
	}

Ci= Oi*Cs * (Ka*ambient() + Kd*Diffuse + (specularcolor * Ks*Phong));
}
