
light
Projectdistant(
    float  intensity=1 ;
    color  lightcolor=1 ;
    point from = point "shader" (0,0,0) ;
    point to   = point "shader" (0,0,1) ;
    float Width = 0.5, Height = 0.5, wedge = .01, hedge = .01;
   float  coneangle = radians(30);
    float  conedeltaangle = radians(5);
    float  beamdistribution = 2;
    string shadowname="";
    string ProjName="";
    float samples=16;
    float width=1;
)
{
 
     float  atten, cosangle;
    uniform vector A = (to - from) / length(to - from);
    uniform float cosoutside= cos(coneangle),
		  cosinside = cos(coneangle-conedeltaangle);

    illuminate( from, A, coneangle ) {

  // solar( to - from, PI/2.0 ) {
	Cl = intensity * lightcolor;
	if(ProjName !="")
		{
	    point PL = transform ("shader", Ps);

		
		point Pslide = Ps / point (Width+wedge, Height+hedge, 1);
	    float zslide = zcomp(Pslide);
	    float xslide = 0.5+0.5*xcomp(Pslide)/zslide;
	    float yslide = 0.5-0.5*ycomp(Pslide)/zslide;
		Cl=intensity*texture(ProjName,xslide,yslide); //,xcomp(PNDC),ycomp(PNDC));
	
		}
	if (shadowname != "") {
		Cl *= 1 - shadow(shadowname, Ps, "samples", samples,
			"swidth", width, "twidth", width);
	}
    }
}
